package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.UserRoleDEFieldsMapper;
import com.sa.ibiz.demo.demo.domain.UserRoleDEFields;
import com.sa.ibiz.demo.demo.service.UserRoleDEFieldsService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.UserRoleDEFieldsSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.UserRoleDEFieldService;
import com.sa.ibiz.demo.demo.service.UserRoleService;

/**
 * 实体[UserRoleDEFields] 服务对象接口实现
 */
@Service
public class UserRoleDEFieldsServiceImpl extends ServiceImplBase<UserRoleDEFieldsMapper, UserRoleDEFields> implements UserRoleDEFieldsService{

    @Autowired
    private UserRoleDEFieldService userroledefieldService;
    @Autowired
    private UserRoleService userroleService;

    @Resource
    private UserRoleDEFieldsMapper userroledefieldsMapper;


    @Override
    public boolean create(UserRoleDEFields et) {
        this.beforeCreate(et);
        String primaryKey=et.getUserroledefieldsid();
        if(StringUtils.isEmpty(primaryKey))
        {
            primaryKey=(String)et.getDefaultPrimaryKey();
            et.setUserroledefieldsid(primaryKey);
         }
         return super.create(et);
    }
    @Override
	public UserRoleDEFields get(UserRoleDEFields et) {
        String primaryKey=et.getUserroledefieldsid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setUserroledefieldsid(primaryKey);
          }
		      return super.get(et);
	}

    @Override
   	public boolean remove(UserRoleDEFields et) {
        String primaryKey=et.getUserroledefieldsid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setUserroledefieldsid(primaryKey);
          }
   		     return super.remove(et);
   	}

    @Override
    public boolean update(UserRoleDEFields et){
        String primaryKey=et.getUserroledefieldsid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setUserroledefieldsid(primaryKey);
          }
		     this.userroledefieldsMapper.updateOne(et);
		     this.get(et);
             return true;
    }


    public Object getEntityKey(UserRoleDEFields et){
		return et.getUserroledefieldsid();  
    }

    @Override
    public boolean getDraft(UserRoleDEFields et)  {
    if((!StringUtils.isEmpty(et.getUserroledefieldid())) && et.getUserroledefield() == null){
            try {
                et.setUserroledefield(userroledefieldService.getById(et.getUserroledefieldid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getUserroleid())) && et.getUserrole() == null){
            try {
                et.setUserrole(userroleService.getById(et.getUserroleid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<UserRoleDEFields> listDefault(UserRoleDEFieldsSearchFilter filter) {
		return userroledefieldsMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<UserRoleDEFields> searchDefault(UserRoleDEFieldsSearchFilter filter) {
		return userroledefieldsMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return userroledefieldsMapper.selectRow(sql);
    }

 }